package quimufu.simple_creator;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.blockrenderlayer.v1.BlockRenderLayerMap;
import net.minecraft.block.Block;
import net.minecraft.client.render.RenderLayer;
import net.minecraft.util.Pair;
import org.apache.logging.log4j.Level;

@Environment(EnvType.CLIENT)
public class SimpleCreatorModClient implements ClientModInitializer {
    @Override
    public void onInitializeClient() {
        SimpleCreatorMod.log(Level.INFO, "Client init");
        for (Pair<Block, String> blockRenderLayerPair : SimpleCreatorMod.BLOCKS_RENDER_LAYER) {
            BlockRenderLayerMap.INSTANCE.putBlock(blockRenderLayerPair.getLeft(), getRenderLayer(blockRenderLayerPair.getRight()));
        }
    }

    private net.minecraft.client.render.RenderLayer getRenderLayer(String renderLayer) {
        return switch (renderLayer.toUpperCase()) {
            case "SOLID" -> RenderLayer.getSolid();
            case "CUTOUT_MIPPED" -> RenderLayer.getCutoutMipped();
            case "CUTOUT" -> RenderLayer.getCutout();
            case "TRANSLUCENT" -> RenderLayer.getTranslucent();
            case "TRANSLUCENT_MOVING_BLOCK" -> RenderLayer.getTranslucentMovingBlock();
            case "LEASH" -> RenderLayer.getLeash();
            case "WATER_MASK" -> RenderLayer.getWaterMask();
            case "ARMOR_ENTITY_GLINT" -> RenderLayer.getArmorEntityGlint();
            case "GLINT_TRANSLUCENT" -> RenderLayer.getGlintTranslucent();
            case "GLINT" -> RenderLayer.getGlint();
            case "ENTITY_GLINT" -> RenderLayer.getEntityGlint();
            case "DIRECT_ENTITY_GLINT" -> RenderLayer.getDirectEntityGlint();
            case "TEXT_BACKGROUND" -> RenderLayer.getTextBackground();
            case "TEXT_BACKGROUND_SEE_THROUGH" -> RenderLayer.getTextBackgroundSeeThrough();
            case "LIGHTNING" -> RenderLayer.getLightning();
            case "DRAGON_RAYS" -> RenderLayer.getDragonRays();
            case "DRAGON_RAYS_DEPTH" -> RenderLayer.getDragonRaysDepth();
            case "TRIPWIRE" -> RenderLayer.getTripwire();
            case "END_PORTAL" -> RenderLayer.getEndPortal();
            case "END_GATEWAY" -> RenderLayer.getEndGateway();
            case "FAST_CLOUDS" -> RenderLayer.getFastClouds();
            case "FANCY_CLOUDS" -> RenderLayer.getFancyClouds();
            case "LINES" -> RenderLayer.getLines();
            case "LINE_STRIP" -> RenderLayer.getLineStrip();
            case "DEBUG_FILLED_BOX" -> RenderLayer.getDebugFilledBox();
            case "DEBUG_QUADS" -> RenderLayer.getDebugQuads();
            case "DEBUG_STRUCTURE_QUADS" -> RenderLayer.getDebugStructureQuads();
            case "DEBUG_SECTION_QUADS" -> RenderLayer.getDebugSectionQuads();
            case "GUI" -> RenderLayer.getGui();
            case "GUI_OVERLAY" -> RenderLayer.getGuiOverlay();
            case "GUI_TEXT_HIGHLIGHT" -> RenderLayer.getGuiTextHighlight();
            case "GUI_GHOST_RECIPE_OVERLAY" -> RenderLayer.getGuiGhostRecipeOverlay();
            default -> {
                SimpleCreatorMod.log(Level.INFO, "Could not find renderLayer " + renderLayer + " using solid");
                yield RenderLayer.getSolid();
            }
        };
    }
}
